#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/syscall.h>
#include <fcntl.h>
#include <signal.h>
#define MAXLINE 200


int counter,status;
float tmp1, tmp2;
int cont,option,h,j,k,t,f,maq,argc,d,g,autscan=0,plosts=0,i=1,e=1;
FILE *names,*archivo,names1,*desc1, *desc11, *desc2, *desc22,*desc3;
char namemaq[10][100];
char impresion[100] ,cata[100],catb[100],rpointer1[100], rpointer2[100], wpointer1[100];
char wpointer2[100],grafica[100],salida[100];
int n,a=1,b=1,npings,intervalo;
char line[MAXLINE];
pid_t arreglo[3];


/*************Comienzo funcion que realiza los pings y crea los archivos base ****************************/


	int pings(int npings,int intervalo )
	{

	       //printf("Comenzando los pings\n");
	       printf("El intervalo de tiempo es %d segundo(s)\n",intervalo);
	       printf("Se realizaran %d pings\n",npings);


		for(e=1;e<=maq;e++)
        	{
			 arreglo[e] =fork();                              //creacion de hijos,
									  //almacenamiento de sus pid.

	        	if(arreglo[e]==0)
			{
			//printf("Soy el hijo %d\n",e);

			sprintf(impresion,"ping -s -n -I %d %s 56 %d|grep time >>texto%d.mmm",intervalo,namemaq[e],npings,e);
			system(impresion);                                                // Realizacion de pings.
			//printf("Actualizando texto%d.txt\n",e);
			//printf("Seleccionando columnas del texto%d\n",e);
			sprintf(cata,"cat texto%d.mmm |awk '{print $6}' |awk -F= '{print $2}'>>time%d.mmm",e,e);
			system(cata);                                         // Seleccion de columnas RTT
			sprintf(catb,"cat texto%d.mmm |awk '{print $5}' |awk -F= '{print $2}'>>nsec%d.mmm",e,e);
			system(catb);                                         // Seleccion de columnas N de paquete

			exit(0);

			}


		}




	for(b=1;b<=maq;b++)
	waitpid(arreglo[b],NULL,0);                        //El padre espera hasta que terminen los hijos,
							   //luego inicia procesamiento de datos

	//printf("Soy el padre\n");
	//printf("Ya estan listos los archivos(terminaron los hijos),comenzare los conteos !!!!!!\n");
	//printf("Comenzando conteo.....\n");

	for(g=1;g<=maq;g++)                     	 // Comienza el acceso a los archivos escritos
							//por los hijos
	{
		sprintf(rpointer1,"time%d.mmm",g);
		sprintf(wpointer1,"time%d.datos",g);
		sprintf(rpointer2,"nsec%d.mmm",g);
		sprintf(wpointer2,"nsec%d.datos",g);
		desc1=fopen(rpointer1,"r");                //desc1,desc11,desc2,desc22 descriptores a
		desc11=fopen(wpointer1,"w");               //archivos time.mmm y nsec.mmm,que permiten
		desc2=fopen(rpointer2,"r");                //la lectura y time.datos y nsec.datos,que seran
		desc22=fopen(wpointer2,"w");               //textos finales a graficar.
		cont=0;
		plosts=0;
		autscan=1;
		tmp2=0;


		for(k=0;k<npings;k++)                          //Conteo de paquetes perdidos y tiempos RTT
		{
			if(autscan==1)                         //autscan=autorizacion de escaneo ,variable
							       //que permite conteo de paquetes perdidos
				fscanf(desc2,"%f\n",&tmp2);
				//printf("\n****************************\n");
			        //printf("El numero de secuencia del ping %d para la maquina %d vale: %f\n",k,g,tmp2);

			if(cont==(int)(tmp2))
			{
				//printf("paquete %d no perdido\n",cont);
				fscanf(desc1,"%f\n",&tmp1);
				fprintf(desc11,"%d\t%f\n",cont,tmp1);
				fprintf(desc22,"%d\t%d\n",cont,plosts);
				cont++;
				autscan=1;
			}
			else if(cont<npings)
				{
				//printf("paquete %d perdido\n",cont);
				plosts=plosts++;
				//printf("Valor acumulado de paquetes perdidos:%d\n",plosts);

				fprintf(desc22,"%d\t%d\n",cont,plosts);
				cont++;
				autscan=0;
			}
		}
		fclose(desc2);
		fclose(desc22);
		fclose(desc1);
		fclose(desc11);

	}
	//printf("Fin de conteo...........\n");

}


/*********************************Comienzo de la funcion que graficara los datos tomados*****************/


	void graficar(char nombre[])                               //le entrego como argumento el nombre
								   // de los archivos de salida

{
			printf("Los archivos se llamaran %s.rtt.ps   y   %s.loss.ps\n",nombre,nombre);
			printf("Graficando Rtt v/s tiempo........\n");

                                                /* Comienzan los pasos para graficar RTT*/
									      // archivo :descriptor de rtt.gnu y luego de loss.gnu
  			archivo=fopen("rtt.gnu","w");                         // Comienzo creacion de
									      //archivo rtt.gnu necesario
									      // para graficar
			fprintf(archivo,"set title  \" Tiempo de RTT v/s numero de Pings\"\n");
			if(option==1)
			fprintf(archivo,"set xlabel \" Tiempo[seg]\"\n");
			if(option==2)
			fprintf(archivo,"set xlabel \" Tiempo[min]\"\n");

			fprintf(archivo,"set ylabel \" Tiempo de RTT \"\n");
			fprintf(archivo,"set grid\n");
			fprintf(archivo,"set terminal postscript landscape color\n");
			sprintf(grafica,"set output \"%s.rtt.ps\"\n",nombre);
			fprintf(archivo,grafica);

			for(h=1;h<=maq;h++)
			{
 				if(h==1)
				{
					sprintf(grafica,"plot \"time%d.datos\" using 1:2 title \"%s\" with points 1, \\\n",h,namemaq[h]);
					fprintf(archivo,grafica);
				}
				else if(h<maq)
				{
					sprintf(grafica,"\"time%d.datos\" using 1:2 title \"%s\" with points 2, \\\n",h,namemaq[h]);
					fprintf(archivo,grafica);
				}
				else
				{
					sprintf(grafica,"\"time%d.datos\" using 1:2 title \"%s\" with points 3 \\\n",h,namemaq[h]);
					fprintf(archivo,grafica);
				}
			}

		fprintf(archivo,"\n");
		fclose(archivo);

                                                                              // Comienzan los pasos para
									      // graficar paquetes perdidos

 		printf("Graficando paquetes perdidos v/s tiempo........\n");
		archivo=fopen("loss.gnu","w");                                       // Comienzo creacion
										     //de archivo loss.gnu
										     //para graficar
		fprintf(archivo,"set title  \" Paquetes perdidos Acumulados\"\n");

		if(option==1)
			fprintf(archivo,"set xlabel \" Tiempo[seg]\"\n");
			if(option==2)
		fprintf(archivo,"set xlabel \" Tiempo[min]\"\n");
		fprintf(archivo,"set ylabel \" Numero de Paquetes Perdidos \"\n");
		fprintf(archivo,"set grid\n");
		fprintf(archivo,"set terminal postscript landscape color\n");
            fprintf(archivo,"set output \"%s.loss.ps\"\n",nombre);

		for(h=1;h<=maq;h++)
			{
				if(h==1)
				{
					sprintf(grafica,"plot \"nsec%d.datos\" using 1:2 title \"%s\" with lines 1, \\\n",h,namemaq[h]);
					fprintf(archivo,grafica);
				}
				else if(h<maq)
				{
					sprintf(grafica,"\"nsec%d.datos\" using 1:2 title \"%s\" with lines 2, \\\n",h,namemaq[h]);
					fprintf(archivo,grafica);
				}
				else
				{
					sprintf(grafica,"\"nsec%d.datos\" using 1:2 title \"%s\" with lines 3 \\\n",h,namemaq[h]);
					fprintf(archivo,grafica);
				}
			}

		fprintf(archivo,"#pause -1");
		fprintf(archivo,"\n");
		fclose(archivo);
		system("gnuplot rtt.gnu");                                      //Graficando rtt
		system("gnuplot loss.gnu");                                     //Graficando loss
		system("rm *.datos *.mmm *.gnu");                               //Borrando archivos residuales

		printf("                                   --------------The End--------------\n");
	//	printf("                                            By MONOMAURO SOFTWARE\n");
		exit(0);

}



/*******************************************Comienzo funcion main*****************************************/


	int main(int argc, char* argv[])
	{
	        d=getopt(argc,argv,"sml");                                     // Obtencion del flag

		printf("\n");
		printf("\n");
		printf("    *********************************************************************\n");
		printf("    *          xxxxxxxxx  xx  xxx       xx  xxxxxxxxx  xxxxxxxxx        *\n");
		printf("    *          xxxxxxxxx  xx  xxxx      xx  xxxxxxxxx  xxxxxxxxx        *\n");
		printf("    *          xx     xx  xx  xx xx     xx  xx         xx               *\n");
		printf("    *          xxxxxxxxx  xx  xx  xx    xx  xx   xxxx  xx               *\n");
		printf("    *          xxxxxxxxx  xx  xx   xx   xx  xx   xxxx  xxxxxxxxx        *\n");
		printf("    *          xx         xx  xx    xx  xx  xx     xx  xxxxxxxxx        *\n");
		printf("    *	       xx         xx  xx     xx xx  xx     xx	      xx	*\n");
		printf("    *	       xx         xx  xx      xxxx  xx     xx         xx	*\n");
		printf("    *	       xx         xx  xx       xxx  xxxxxxxxx  xxxxxxxxx	*\n");
		printf("    *	       xx         xx  xx        xx  xxxxxxxxx  xxxxxxxxx	*\n");
		printf("    *								        *\n");
		//printf("    *                                               by monomauro TM     *\n");
		printf("    *********************************************************************\n");
		printf("\n");


		//printf("Nombre del archivo de salida %s\n",argv[3]);
		//out=(fopen(argv[3],"r"));

		names=(fopen(argv[2],"r"));                             // names: descriptor de archivo
									// con maquinas para "pingear"

		while((fscanf(names,"%s\n",&namemaq[i]))!=EOF)
			{
	      		printf("El nombre de la %d maquina es:%s\n",i,namemaq[i]);
	    		i++;
			}
		fclose(names);

		maq=i-1;
 		//printf("Cantidad de maquinas:%d\n",maq);

		if(argc != 4)
  		{
   		 printf("Falta algn argumento!!!!! \n");
    	 	exit(1);
  		}



		switch(d)                                        // Casos dependiendo del flag
		{       case -1:
				printf("flag non-set\n");
				break;

			case 's':printf("short mode on\n");
			npings=5;
			intervalo=1;
			option=1;                               //option ,permite graficar en segundos o minutos
		        pings(npings,intervalo);		//Llamado a funcion que realiza los pings,
								//se le entrega el numero de pings y el
								//intervalo entre ellos

			graficar(argv[3]);                      //Llamado a funcion que graficara,se le entrega
								// el nombre de los archivos de salida
			break;


			case 'm':printf("Medium mode on\n");
			npings=80;
			intervalo=1;
			option=2;
		        pings(npings,intervalo);		//Llamado a funcion que realiza los pings,
								//se le entrega el numero de pings y el
								//intervalo entre ellos

			graficar(argv[3]);                      //Llamado a funcion que graficara,se le entrega
								// el nombre de los archivos de salida
			break;



			case 'l':printf("long mode on\n");
			npings=1440;
			intervalo=60;
			option=2;
			pings(npings,intervalo);		//Llamado a funcion que realiza los pings,
								//se le entrega el numero de pings y el
								//intervalo entre ellos

			graficar(argv[3]);                      //Llamado a funcion que graficara,se le entrega
								// el nombre de los archivos de salida
			break;


			default:                                 // Flag no permitido
				printf("Invalid mode\n");
				exit(0);



		}

		exit(0);

}


